#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     W3PERL LIBRAIRY                            #####
####                                                                #####
####                      (http server)                             #####
####                                                                #####
####    domisse@w3perl.com                   version 21/04/2007     #####
####                                                                #####
####                                                                #####
#########################################################################

$car = substr($pathserver,1,1);
$nt = 1 if ($car eq ':');

unless (defined $perlpath) {
    open(ME,$0) || die "Can't open $0\n";
    $perlpath = <ME>;
    chop($perlpath);
    close(ME);
    $perlpath =~ s/\#\!//;
}

### Check Geographic IP mapping modules

&check_module("Geo::IPfree","Can't resolve IP address") if ($geoip_free == 1);
&check_module("GEO::IP","Can't resolve IP address") if ($netgeo == 1);

### Check mail modules

# If all modules installed, default would be the last one
#@mail_module = ("Mail::Sendmail","MIME::Lite");
@mail_module = ("MIME::Lite");

if ($enable_email == 1) {
    $perl_mail_module = &check_mail_module(@mail_module);
    &check_module($perl_mail_module,"Can't send email report");
#    &check_module("Mail::Sendmail","Can't send email report");
    if ($perl_mail_module eq '') {
	&error_exit("No perl module found to send mail");
    }
#    if ($email_pdf == 1 && $perl_mail_module eq "Mail::Sendmail") {
#	&check_module("MIME::Base64","Can't send email attachment");
#	&check_module("MIME::QuotedPrint","Can't send email attachment");
#    }
}

sub check_mail_module {
    local(@list_module) = @_;
    local($i,$found_mail_module,$mail_module);

    $found_mail_module = 0;
    $mail_module = '';
    for ($i=0;$i<=$#list_module;$i++) {
	$commit = system("$perlpath -e 'use $list_module[$i]'\n");
	if ($commit == 0) {
	    $found_mail_module = 1;
	    $mail_module = $list_module[$i];
	}
    }
    return $mail_module;
}


sub check_module {
    local($module,$msg) = @_;

    $commit = system("$perlpath -e 'use $module'\n");

    if ($commit != 0) {
	$msg = "\n$module module missing. $msg\n";
	$msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg .= "If you want to install the GEO::IP module\n";
	$msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	if ($nt == 1) {
	    $msg .= " - Go to your Perl installation path (usually C:\Perl) and type :\n";
	    $msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $msg .= "'ppm'\n";
	    $msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $msg .= "At the prompt 'PPM>' type :\n";
	    $msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $msg .= "'install $module'\n"; 
	    $msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	}
	if ($nt == 0) {
	    $msg .= " - Use CPAN to download the required modules, type :\n";
	    $msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $msg .= "'perl -MCPAN -e shell'\n";
	    $msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $msg .= "At the prompt 'cpan>' type :\n";
	    $msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $msg .= "'install $module'\n";
	    $msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	}
	&error_exit($msg);
    } else {
#	require $module;
	if ($enable_email == 1) {
#	    if ($perl_mail_module eq "Mail::Sendmail") {
#		require Mail::Sendmail;
#		if ($email_pdf == 1) {
#		    require MIME::Base64;
#		    require MIME::QuotedPrint;
#		}
#	    }
	    if ($perl_mail_module eq "MIME::Lite") {
		require MIME::Lite;
	    }
	}
	if ($netgeo == 1) {
	    require GEO::IP;
	}
	if ($geoip_free == 1) {
	    require Geo::IPfree;
	}
    }
}

1;
